import {DOMRenderer as $42h8L$DOMRenderer} from "dom-renderer";
import {autorun as $42h8L$autorun, reaction as $42h8L$reaction, observable as $42h8L$observable} from "mobx";
import {toCamelCase as $42h8L$toCamelCase, parseJSON as $42h8L$parseJSON, isHTMLElementClass as $42h8L$isHTMLElementClass, toHyphenCase as $42h8L$toHyphenCase, isEmpty as $42h8L$isEmpty, stringifyDOM as $42h8L$stringifyDOM, delegate as $42h8L$delegate} from "web-utility";
import {jsx as $42h8L$jsx, Fragment as $42h8L$Fragment} from "dom-renderer/jsx-runtime";


function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
var $0c03e47eb1097734$exports = {};

$parcel$export($0c03e47eb1097734$exports, "observer", function () { return $0c03e47eb1097734$export$b6ae1bc530f4c149; });
$parcel$export($0c03e47eb1097734$exports, "attribute", function () { return $0c03e47eb1097734$export$af4b9a83f4b00434; });
$parcel$export($0c03e47eb1097734$exports, "reaction", function () { return $0c03e47eb1097734$export$7203b476385689ae; });



var $e761a8735a18346a$exports = {};

$parcel$export($e761a8735a18346a$exports, "getMobxData", function () { return $e761a8735a18346a$export$b06b4c21253e26e2; });
function $e761a8735a18346a$export$b06b4c21253e26e2(observable) {
    var _a;
    for (const key of Object.getOwnPropertySymbols(observable)){
        const store = (_a = observable[key]) === null || _a === void 0 ? void 0 : _a.values_;
        if (store instanceof Map) return Object.fromEntries(Array.from(store, ([key, { value_: value_ }])=>[
                key,
                value_
            ]));
    }
}


function $0c03e47eb1097734$var$wrapFunction(func) {
    return (props)=>{
        var tree, renderer = new (0, $42h8L$DOMRenderer)();
        const disposer = (0, $42h8L$autorun)(()=>{
            const newTree = func(props);
            tree = tree ? renderer.patch(tree, newTree) : newTree;
        });
        const { unRef: unRef } = tree;
        tree.ref = (node)=>tree.node = node;
        tree.unRef = (node)=>(disposer(), unRef === null || unRef === void 0 ? void 0 : unRef(node));
        return tree;
    };
}
const $0c03e47eb1097734$var$reactionMap = new WeakMap();
function $0c03e47eb1097734$var$wrapClass(Component) {
    class ObserverComponent extends Component {
        get props() {
            return (0, $e761a8735a18346a$export$b06b4c21253e26e2)(this);
        }
        constructor(){
            super();
            Object.defineProperty(this, "disposers", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: []
            });
            const { update: update } = Object.getPrototypeOf(this);
            this["update"] = ()=>this.disposers.push((0, $42h8L$autorun)(()=>update.call(this)));
        }
        connectedCallback() {
            var _a;
            const names = this.constructor["observedAttributes"] || [], reactions = $0c03e47eb1097734$var$reactionMap.get(this) || [];
            this.disposers.push(...names.map((name)=>(0, $42h8L$autorun)(()=>this.syncPropAttr(name))), ...reactions.map(({ expression: expression, effect: effect })=>(0, $42h8L$reaction)((reaction)=>expression(this, reaction), effect.bind(this))));
            (_a = super["connectedCallback"]) === null || _a === void 0 || _a.call(this);
        }
        disconnectedCallback() {
            for (const disposer of this.disposers)disposer();
            this.disposers.length = 0;
        }
        attributeChangedCallback(name, old, value) {
            var _a;
            this[(0, $42h8L$toCamelCase)(name)] = (0, $42h8L$parseJSON)(value);
            (_a = super["attributeChangedCallback"]) === null || _a === void 0 || _a.call(this, name, old, value);
        }
        syncPropAttr(name) {
            var _a;
            var value = this[(0, $42h8L$toCamelCase)(name)];
            if (!(value != null) || value === false) return this.removeAttribute(name);
            value = value === true ? name : value;
            if (typeof value === "object") {
                value = (_a = value.toJSON) === null || _a === void 0 ? void 0 : _a.call(value);
                value = typeof value === "object" ? JSON.stringify(value) : value;
            }
            super.setAttribute(name, value);
        }
    }
    return ObserverComponent;
}
function $0c03e47eb1097734$export$b6ae1bc530f4c149(func, _) {
    return (0, $42h8L$isHTMLElementClass)(func) ? $0c03e47eb1097734$var$wrapClass(func) : $0c03e47eb1097734$var$wrapFunction(func);
}
function $0c03e47eb1097734$export$af4b9a83f4b00434(_, { name: name, addInitializer: addInitializer }) {
    addInitializer(function() {
        const { constructor: constructor } = this;
        var names = constructor["observedAttributes"];
        if (!names) {
            names = [];
            Object.defineProperty(constructor, "observedAttributes", {
                configurable: true,
                get: ()=>names
            });
        }
        names.push((0, $42h8L$toHyphenCase)(name.toString()));
    });
}
function $0c03e47eb1097734$export$7203b476385689ae(expression) {
    return (effect, { addInitializer: addInitializer })=>addInitializer(function() {
            const reactions = $0c03e47eb1097734$var$reactionMap.get(this) || [];
            reactions.push({
                expression: expression,
                effect: effect
            });
            $0c03e47eb1097734$var$reactionMap.set(this, reactions);
        });
}



var $317b1f21909c74b8$exports = {};

$parcel$export($317b1f21909c74b8$exports, "component", function () { return $317b1f21909c74b8$export$d8556a2a8f973135; });
$parcel$export($317b1f21909c74b8$exports, "on", function () { return $317b1f21909c74b8$export$af631764ddc44097; });



const $317b1f21909c74b8$var$eventMap = new WeakMap();
function $317b1f21909c74b8$export$d8556a2a8f973135(meta) {
    return (Class, { addInitializer: addInitializer })=>{
        class RendererComponent extends Class {
            get root() {
                return this.internals.shadowRoot || this;
            }
            constructor(){
                super();
                Object.defineProperty(this, "internals", {
                    enumerable: true,
                    configurable: true,
                    writable: true,
                    value: this.attachInternals()
                });
                Object.defineProperty(this, "renderer", {
                    enumerable: true,
                    configurable: true,
                    writable: true,
                    value: new (0, $42h8L$DOMRenderer)()
                });
                if (meta.mode && !this.internals.shadowRoot) this.attachShadow(meta);
            }
            connectedCallback() {
                var _a;
                this.update();
                const { mode: mode } = meta;
                const renderChildren = !(mode != null);
                const { root: root } = this, events = $317b1f21909c74b8$var$eventMap.get(this) || [];
                for (const { type: type, selector: selector, handler: handler } of events){
                    if (renderChildren && /^:host/.test(selector)) console.warn(`[WebCell] DOM Event delegation of "${selector}" won't work if you don't invoke "this.attachShadow()" manually.`);
                    root.addEventListener(type, handler);
                }
                (_a = super["connectedCallback"]) === null || _a === void 0 || _a.call(this);
            }
            update() {
                var _a;
                const vNode = (_a = this.render) === null || _a === void 0 ? void 0 : _a.call(this);
                this.renderer.render((0, $42h8L$isEmpty)(vNode) ? (0, $42h8L$jsx)((0, $42h8L$Fragment), {}) : vNode, this.root);
            }
            disconnectedCallback() {
                var _a;
                const { root: root } = this, events = $317b1f21909c74b8$var$eventMap.get(this) || [];
                for (const { type: type, handler: handler } of events)root.removeEventListener(type, handler);
                (_a = super["disconnectedCallback"]) === null || _a === void 0 || _a.call(this);
            }
            emit(event, detail, { cancelable: cancelable, bubbles: bubbles, composed: composed } = {}) {
                return this.dispatchEvent(new CustomEvent(event, {
                    detail: detail,
                    cancelable: cancelable,
                    bubbles: bubbles,
                    composed: composed
                }));
            }
            toString() {
                return (0, $42h8L$stringifyDOM)(this.root);
            }
        }
        addInitializer(function() {
            var _a;
            (_a = globalThis.customElements) === null || _a === void 0 || _a.define(meta.tagName, this, meta);
        });
        return RendererComponent;
    };
}
function $317b1f21909c74b8$export$af631764ddc44097(type, selector) {
    return (method, { addInitializer: addInitializer })=>addInitializer(function() {
            const events = $317b1f21909c74b8$var$eventMap.get(this) || [], handler = (0, $42h8L$delegate)(selector, method.bind(this));
            events.push({
                type: type,
                selector: selector,
                handler: handler
            });
            $317b1f21909c74b8$var$eventMap.set(this, events);
        });
}


var $29675797ddd6c4f7$exports = {};

$parcel$export($29675797ddd6c4f7$exports, "formField", function () { return $29675797ddd6c4f7$export$2a668e8d088a0667; });


var $29675797ddd6c4f7$var$__esDecorate = undefined && undefined.__esDecorate || function(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) {
        if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected");
        return f;
    }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for(var i = decorators.length - 1; i >= 0; i--){
        var context = {};
        for(var p in contextIn)context[p] = p === "access" ? {} : contextIn[p];
        for(var p in contextIn.access)context.access[p] = contextIn.access[p];
        context.addInitializer = function(f) {
            if (done) throw new TypeError("Cannot add initializers after decoration has completed");
            extraInitializers.push(accept(f || null));
        };
        var result = (0, decorators[i])(kind === "accessor" ? {
            get: descriptor.get,
            set: descriptor.set
        } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        } else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var $29675797ddd6c4f7$var$__runInitializers = undefined && undefined.__runInitializers || function(thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for(var i = 0; i < initializers.length; i++)value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    return useValue ? value : void 0;
};
var $29675797ddd6c4f7$var$__classPrivateFieldGet = undefined && undefined.__classPrivateFieldGet || function(receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var $29675797ddd6c4f7$var$__classPrivateFieldSet = undefined && undefined.__classPrivateFieldSet || function(receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value), value;
};
function $29675797ddd6c4f7$export$2a668e8d088a0667(Class, _) {
    let FormFieldComponent = (()=>{
        var _a, _FormFieldComponent_name_accessor_storage, _FormFieldComponent_value_accessor_storage, _FormFieldComponent_required_accessor_storage, _FormFieldComponent_disabled_accessor_storage, _FormFieldComponent_autofocus_accessor_storage;
        let _classSuper = Class;
        let _instanceExtraInitializers = [];
        let _setValue_decorators;
        let _name_decorators;
        let _name_initializers = [];
        let _value_decorators;
        let _value_initializers = [];
        let _required_decorators;
        let _required_initializers = [];
        let _disabled_decorators;
        let _disabled_initializers = [];
        let _autofocus_decorators;
        let _autofocus_initializers = [];
        return _a = class FormFieldComponent extends _classSuper {
            constructor(){
                super(...arguments);
                _FormFieldComponent_name_accessor_storage.set(this, ($29675797ddd6c4f7$var$__runInitializers(this, _instanceExtraInitializers), $29675797ddd6c4f7$var$__runInitializers(this, _name_initializers, void 0)));
                _FormFieldComponent_value_accessor_storage.set(this, $29675797ddd6c4f7$var$__runInitializers(this, _value_initializers, void 0));
                _FormFieldComponent_required_accessor_storage.set(this, $29675797ddd6c4f7$var$__runInitializers(this, _required_initializers, void 0));
                _FormFieldComponent_disabled_accessor_storage.set(this, $29675797ddd6c4f7$var$__runInitializers(this, _disabled_initializers, void 0));
                _FormFieldComponent_autofocus_accessor_storage.set(this, $29675797ddd6c4f7$var$__runInitializers(this, _autofocus_initializers, void 0));
            }
            setValue(value) {
                this.internals.setFormValue(value);
            }
            formDisabledCallback(disabled) {
                this.disabled = disabled;
            }
            get name() {
                return $29675797ddd6c4f7$var$__classPrivateFieldGet(this, _FormFieldComponent_name_accessor_storage, "f");
            }
            set name(value) {
                $29675797ddd6c4f7$var$__classPrivateFieldSet(this, _FormFieldComponent_name_accessor_storage, value, "f");
            }
            get value() {
                return $29675797ddd6c4f7$var$__classPrivateFieldGet(this, _FormFieldComponent_value_accessor_storage, "f");
            }
            set value(value) {
                $29675797ddd6c4f7$var$__classPrivateFieldSet(this, _FormFieldComponent_value_accessor_storage, value, "f");
            }
            get required() {
                return $29675797ddd6c4f7$var$__classPrivateFieldGet(this, _FormFieldComponent_required_accessor_storage, "f");
            }
            set required(value) {
                $29675797ddd6c4f7$var$__classPrivateFieldSet(this, _FormFieldComponent_required_accessor_storage, value, "f");
            }
            get disabled() {
                return $29675797ddd6c4f7$var$__classPrivateFieldGet(this, _FormFieldComponent_disabled_accessor_storage, "f");
            }
            set disabled(value) {
                $29675797ddd6c4f7$var$__classPrivateFieldSet(this, _FormFieldComponent_disabled_accessor_storage, value, "f");
            }
            get autofocus() {
                return $29675797ddd6c4f7$var$__classPrivateFieldGet(this, _FormFieldComponent_autofocus_accessor_storage, "f");
            }
            set autofocus(value) {
                $29675797ddd6c4f7$var$__classPrivateFieldSet(this, _FormFieldComponent_autofocus_accessor_storage, value, "f");
            }
            set defaultValue(raw) {
                var _b;
                this.setAttribute("value", raw);
                (_b = this.value) !== null && _b !== void 0 ? _b : this.value = raw;
            }
            get defaultValue() {
                return this.getAttribute("value");
            }
            get form() {
                return this.internals.form;
            }
            get validity() {
                return this.internals.validity;
            }
            get validationMessage() {
                return this.internals.validationMessage;
            }
            get willValidate() {
                return this.internals.willValidate;
            }
            checkValidity() {
                return this.internals.checkValidity();
            }
            reportValidity() {
                return this.internals.reportValidity();
            }
        }, _FormFieldComponent_name_accessor_storage = new WeakMap(), _FormFieldComponent_value_accessor_storage = new WeakMap(), _FormFieldComponent_required_accessor_storage = new WeakMap(), _FormFieldComponent_disabled_accessor_storage = new WeakMap(), _FormFieldComponent_autofocus_accessor_storage = new WeakMap(), (()=>{
            var _b;
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create((_b = _classSuper[Symbol.metadata]) !== null && _b !== void 0 ? _b : null) : void 0;
            _setValue_decorators = [
                (0, $0c03e47eb1097734$export$7203b476385689ae)(({ value: value })=>value)
            ];
            _name_decorators = [
                (0, $0c03e47eb1097734$export$af4b9a83f4b00434),
                (0, $42h8L$observable)
            ];
            _value_decorators = [
                (0, $42h8L$observable)
            ];
            _required_decorators = [
                (0, $0c03e47eb1097734$export$af4b9a83f4b00434),
                (0, $42h8L$observable)
            ];
            _disabled_decorators = [
                (0, $0c03e47eb1097734$export$af4b9a83f4b00434),
                (0, $42h8L$observable)
            ];
            _autofocus_decorators = [
                (0, $0c03e47eb1097734$export$af4b9a83f4b00434),
                (0, $42h8L$observable)
            ];
            $29675797ddd6c4f7$var$__esDecorate(_a, null, _setValue_decorators, {
                kind: "method",
                name: "setValue",
                static: false,
                private: false,
                access: {
                    has: (obj)=>"setValue" in obj,
                    get: (obj)=>obj.setValue
                },
                metadata: _metadata
            }, null, _instanceExtraInitializers);
            $29675797ddd6c4f7$var$__esDecorate(_a, null, _name_decorators, {
                kind: "accessor",
                name: "name",
                static: false,
                private: false,
                access: {
                    has: (obj)=>"name" in obj,
                    get: (obj)=>obj.name,
                    set: (obj, value)=>{
                        obj.name = value;
                    }
                },
                metadata: _metadata
            }, _name_initializers, _instanceExtraInitializers);
            $29675797ddd6c4f7$var$__esDecorate(_a, null, _value_decorators, {
                kind: "accessor",
                name: "value",
                static: false,
                private: false,
                access: {
                    has: (obj)=>"value" in obj,
                    get: (obj)=>obj.value,
                    set: (obj, value)=>{
                        obj.value = value;
                    }
                },
                metadata: _metadata
            }, _value_initializers, _instanceExtraInitializers);
            $29675797ddd6c4f7$var$__esDecorate(_a, null, _required_decorators, {
                kind: "accessor",
                name: "required",
                static: false,
                private: false,
                access: {
                    has: (obj)=>"required" in obj,
                    get: (obj)=>obj.required,
                    set: (obj, value)=>{
                        obj.required = value;
                    }
                },
                metadata: _metadata
            }, _required_initializers, _instanceExtraInitializers);
            $29675797ddd6c4f7$var$__esDecorate(_a, null, _disabled_decorators, {
                kind: "accessor",
                name: "disabled",
                static: false,
                private: false,
                access: {
                    has: (obj)=>"disabled" in obj,
                    get: (obj)=>obj.disabled,
                    set: (obj, value)=>{
                        obj.disabled = value;
                    }
                },
                metadata: _metadata
            }, _disabled_initializers, _instanceExtraInitializers);
            $29675797ddd6c4f7$var$__esDecorate(_a, null, _autofocus_decorators, {
                kind: "accessor",
                name: "autofocus",
                static: false,
                private: false,
                access: {
                    has: (obj)=>"autofocus" in obj,
                    get: (obj)=>obj.autofocus,
                    set: (obj, value)=>{
                        obj.autofocus = value;
                    }
                },
                metadata: _metadata
            }, _autofocus_initializers, _instanceExtraInitializers);
            if (_metadata) Object.defineProperty(_a, Symbol.metadata, {
                enumerable: true,
                configurable: true,
                writable: true,
                value: _metadata
            });
        })(), Object.defineProperty(_a, "formAssociated", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        }), _a;
    })();
    return FormFieldComponent;
}


var $8acf79bd061a8fc3$exports = {};

$parcel$export($8acf79bd061a8fc3$exports, "AsyncBox", function () { return $8acf79bd061a8fc3$export$decd3a6e19d9ddcb; });
$parcel$export($8acf79bd061a8fc3$exports, "lazy", function () { return $8acf79bd061a8fc3$export$488013bae63b21da; });




var $8acf79bd061a8fc3$var$__runInitializers = undefined && undefined.__runInitializers || function(thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for(var i = 0; i < initializers.length; i++)value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    return useValue ? value : void 0;
};
var $8acf79bd061a8fc3$var$__esDecorate = undefined && undefined.__esDecorate || function(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) {
        if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected");
        return f;
    }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for(var i = decorators.length - 1; i >= 0; i--){
        var context = {};
        for(var p in contextIn)context[p] = p === "access" ? {} : contextIn[p];
        for(var p in contextIn.access)context.access[p] = contextIn.access[p];
        context.addInitializer = function(f) {
            if (done) throw new TypeError("Cannot add initializers after decoration has completed");
            extraInitializers.push(accept(f || null));
        };
        var result = (0, decorators[i])(kind === "accessor" ? {
            get: descriptor.get,
            set: descriptor.set
        } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        } else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var $8acf79bd061a8fc3$var$__setFunctionName = undefined && undefined.__setFunctionName || function(f, name, prefix) {
    if (typeof name === "symbol") name = name.description ? "[".concat(name.description, "]") : "";
    return Object.defineProperty(f, "name", {
        configurable: true,
        value: prefix ? "".concat(prefix, " ", name) : name
    });
};
var $8acf79bd061a8fc3$var$__classPrivateFieldGet = undefined && undefined.__classPrivateFieldGet || function(receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var $8acf79bd061a8fc3$var$__classPrivateFieldSet = undefined && undefined.__classPrivateFieldSet || function(receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value), value;
};
var $8acf79bd061a8fc3$var$__rest = undefined && undefined.__rest || function(s, e) {
    var t = {};
    for(var p in s)if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function") {
        for(var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++)if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
    }
    return t;
};
let $8acf79bd061a8fc3$export$decd3a6e19d9ddcb = (()=>{
    var _AsyncBox_component_accessor_storage, _AsyncBox_delegatedProps_accessor_storage;
    let _classDecorators = [
        (0, $317b1f21909c74b8$export$d8556a2a8f973135)({
            tagName: "async-box"
        }),
        (0, $0c03e47eb1097734$export$b6ae1bc530f4c149)
    ];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = HTMLElement;
    let _instanceExtraInitializers = [];
    let _component_decorators;
    let _component_initializers = [];
    let _delegatedProps_decorators;
    let _delegatedProps_initializers = [];
    var AsyncBox = _classThis = class extends _classSuper {
        constructor(){
            super(...arguments);
            Object.defineProperty(this, "loader", {
                enumerable: true,
                configurable: true,
                writable: true,
                value: ($8acf79bd061a8fc3$var$__runInitializers(this, _instanceExtraInitializers), void 0)
            });
            _AsyncBox_component_accessor_storage.set(this, $8acf79bd061a8fc3$var$__runInitializers(this, _component_initializers, void 0));
            _AsyncBox_delegatedProps_accessor_storage.set(this, $8acf79bd061a8fc3$var$__runInitializers(this, _delegatedProps_initializers, void 0));
        }
        get component() {
            return $8acf79bd061a8fc3$var$__classPrivateFieldGet(this, _AsyncBox_component_accessor_storage, "f");
        }
        set component(value) {
            $8acf79bd061a8fc3$var$__classPrivateFieldSet(this, _AsyncBox_component_accessor_storage, value, "f");
        }
        get delegatedProps() {
            return $8acf79bd061a8fc3$var$__classPrivateFieldGet(this, _AsyncBox_delegatedProps_accessor_storage, "f");
        }
        set delegatedProps(value) {
            $8acf79bd061a8fc3$var$__classPrivateFieldSet(this, _AsyncBox_delegatedProps_accessor_storage, value, "f");
        }
        connectedCallback() {
            this.load();
        }
        async load() {
            this.component = undefined;
            const Tag = await this.loader();
            this.component = (_a)=>{
                var { children: children } = _a, props = $8acf79bd061a8fc3$var$__rest(_a, [
                    "children"
                ]);
                return (0, $42h8L$jsx)(Tag, Object.assign({}, props, {
                    children: children
                }));
            };
            this.emit("load", this.component);
        }
        render() {
            const { component: Tag, props: props, delegatedProps: delegatedProps } = this;
            const _a = Object.assign(Object.assign({}, props), delegatedProps), { children: children } = _a, data = $8acf79bd061a8fc3$var$__rest(_a, [
                "children"
            ]);
            return Tag && (0, $42h8L$jsx)(Tag, Object.assign({}, data, {
                children: children
            }));
        }
    };
    _AsyncBox_component_accessor_storage = new WeakMap();
    _AsyncBox_delegatedProps_accessor_storage = new WeakMap();
    $8acf79bd061a8fc3$var$__setFunctionName(_classThis, "AsyncBox");
    (()=>{
        var _a;
        const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create((_a = _classSuper[Symbol.metadata]) !== null && _a !== void 0 ? _a : null) : void 0;
        _component_decorators = [
            (0, $42h8L$observable)
        ];
        _delegatedProps_decorators = [
            (0, $42h8L$observable)
        ];
        $8acf79bd061a8fc3$var$__esDecorate(_classThis, null, _component_decorators, {
            kind: "accessor",
            name: "component",
            static: false,
            private: false,
            access: {
                has: (obj)=>"component" in obj,
                get: (obj)=>obj.component,
                set: (obj, value)=>{
                    obj.component = value;
                }
            },
            metadata: _metadata
        }, _component_initializers, _instanceExtraInitializers);
        $8acf79bd061a8fc3$var$__esDecorate(_classThis, null, _delegatedProps_decorators, {
            kind: "accessor",
            name: "delegatedProps",
            static: false,
            private: false,
            access: {
                has: (obj)=>"delegatedProps" in obj,
                get: (obj)=>obj.delegatedProps,
                set: (obj, value)=>{
                    obj.delegatedProps = value;
                }
            },
            metadata: _metadata
        }, _delegatedProps_initializers, _instanceExtraInitializers);
        $8acf79bd061a8fc3$var$__esDecorate(null, _classDescriptor = {
            value: _classThis
        }, _classDecorators, {
            kind: "class",
            name: _classThis.name,
            metadata: _metadata
        }, null, _classExtraInitializers);
        AsyncBox = _classThis = _classDescriptor.value;
        if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, {
            enumerable: true,
            configurable: true,
            writable: true,
            value: _metadata
        });
        $8acf79bd061a8fc3$var$__runInitializers(_classThis, _classExtraInitializers);
    })();
    return AsyncBox = _classThis;
})();
function $8acf79bd061a8fc3$export$488013bae63b21da(loader) {
    return (props)=>(0, $42h8L$jsx)($8acf79bd061a8fc3$export$decd3a6e19d9ddcb, {
            delegatedProps: props,
            loader: async ()=>(await loader()).default
        });
}




export {$0c03e47eb1097734$export$b6ae1bc530f4c149 as observer, $0c03e47eb1097734$export$af4b9a83f4b00434 as attribute, $0c03e47eb1097734$export$7203b476385689ae as reaction, $e761a8735a18346a$export$b06b4c21253e26e2 as getMobxData, $317b1f21909c74b8$export$d8556a2a8f973135 as component, $317b1f21909c74b8$export$af631764ddc44097 as on, $29675797ddd6c4f7$export$2a668e8d088a0667 as formField, $8acf79bd061a8fc3$export$decd3a6e19d9ddcb as AsyncBox, $8acf79bd061a8fc3$export$488013bae63b21da as lazy};
//# sourceMappingURL=index.esm.js.map
